#include <stdlib.h>
#include <iostream>
using namespace std;

// функции вычисления факториала:

unsigned long long fact1( int n ) {
   unsigned long long f = 1;
   int i;
   for( i = 1; i <= n; i++ ) f *= i;
   return f;
}

unsigned long long fact2( int n ) {
   unsigned long long f = 1;
   while( n > 1 ) f *= n--;
   return f;
}

unsigned long long fact3( int n ) {
   return 0 == n || 1 == n ? 1 : n * fact3( n - 1 );
}

//--------------------------------------------------

unsigned long long ( *funcs[] )( int ) = { 
   fact1, fact2, fact3   // таблица функций
};
const uint nfuncs = sizeof( funcs ) / sizeof( funcs[ 0 ] );

int main( int argc, char **argv, char **envp ) {
   uint n;
   while( 1 ) {
      cout << "число: ";
      cin >> n;      
      cout << n << "! => ";
      for( uint i = 0; i < nfuncs; i++ ) 
         cout << funcs[ i ]( n ) << ( i == nfuncs - 1 ? "\n" : " , " );
   }
   return 0;
}
